Client webhooks

Webhooks are user-defined HTTP callbacks that customers can code to interact with the Pismo platform during certain operations. Client webhooks should be registered with Pismo during setup. Talk to your Pismo representative about getting these implemented.

📘

Pismo webhook security

For information on webhook security, refer to Verifying webhook requests.

Client anti-fraud webhook for card tokenization

As a card issuer, you can provide your own anti-fraud card verification via a webhook that Pismo calls during the tokenization process. If you don't provide one, Pismo uses a default anti-fraud method. You need to configure this webhook with your Pismo representative.

You can:

  • Approve a card
  • Not approve a card
  • Ask Pismo to prompt the cardholder for further identity and verification in the form of SMS, phone call, or app.

For more information, refer to Card tokenization process and onboarding and Card tokenization flow and events.

Webhook specifications
Request fields
<Table align={["left","left","left","left"]}>
  <thead>
    <tr>
      <th style={{ textAlign: "left" }}>
        Field
      </th>

      <th style={{ textAlign: "left" }}>
        Type
      </th>

      <th style={{ textAlign: "left" }}>
        Description
      </th>

      <th style={{ textAlign: "left" }}>
        Required
      </th>
    </tr>
  </thead>

  <tbody>
    <tr>
      <td style={{ textAlign: "left" }}>
        `custom_codes`
      </td>

      <td style={{ textAlign: "left" }}>
        string array
      </td>

      <td style={{ textAlign: "left" }}>
        Card status validation codes indicating Pismo's findings. Issuer can still approve. Note that custom codes are listed elsewhere, but not all apply to this webhook.

        Refer to Custom codes table below.
      </td>

      <td style={{ textAlign: "left" }}>
        No
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        `token_id`
      </td>

      <td style={{ textAlign: "left" }}>
        number
      </td>

      <td style={{ textAlign: "left" }}>
        Pismo-issued token ID. You can use this to call the [Get token information](https://developers.pismo.io/pismo-docs/reference/gettokeninfo) endpoint.
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        `network_brand`
      </td>

      <td style={{ textAlign: "left" }}>
        enum string
      </td>

      <td style={{ textAlign: "left" }}>
        * `vts` -  Visa
        * `mdes` - Mastercard
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        `network_call_method`
      </td>

      <td style={{ textAlign: "left" }}>
        enum string
      </td>

      <td style={{ textAlign: "left" }}>
        * `VTS_DEVICE_BINDING`
        * `TA`
        * `VTS_APPROVE_PROVSIONING`
        * `VTS_APPROVE_PROVISIONG_ISO`
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        `card`
      </td>

      <td style={{ textAlign: "left" }}>
        object
      </td>

      <td style={{ textAlign: "left" }} />

      <td style={{ textAlign: "left" }} />
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `id`
      </td>

      <td style={{ textAlign: "left" }}>
        number
      </td>

      <td style={{ textAlign: "left" }}>
        Pismo-assigned card ID
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `type`
      </td>

      <td style={{ textAlign: "left" }}>
        enum string
      </td>

      <td style={{ textAlign: "left" }}>
        Card type:

        * `PLASTIC`
        * `VIRTUAL`
        * `RECURRING`
        * `TEMPORARY`
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        `program_id`
      </td>

      <td style={{ textAlign: "left" }}>
        number
      </td>

      <td style={{ textAlign: "left" }}>
        Program ID
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        `bin`
      </td>

      <td style={{ textAlign: "left" }}>
        string
      </td>

      <td style={{ textAlign: "left" }}>
        Bank identification number
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `status`
      </td>

      <td style={{ textAlign: "left" }}>
        enum string
      </td>

      <td style={{ textAlign: "left" }}>
        Card status:

        * `created`
        * `normal`
        * `damaged`
        * `warning`
        * `lost`
        * `unknown`
      </td>

      <td style={{ textAlign: "left" }}>
        No
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `stage`
      </td>

      <td style={{ textAlign: "left" }}>
        enum string
      </td>

      <td style={{ textAlign: "left" }}>
        Card lifecycle status

        * `unknown`
        * `blocked`
        * `unblocked`
      </td>

      <td style={{ textAlign: "left" }}>
        No
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        `combo_card`
      </td>

      <td style={{ textAlign: "left" }}>
        object
      </td>

      <td style={{ textAlign: "left" }} />

      <td style={{ textAlign: "left" }}>
        No
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `status`
      </td>

      <td style={{ textAlign: "left" }}>
        enum string
      </td>

      <td style={{ textAlign: "left" }}>
        Card status:

        * `created`
        * `normal`
        * `damaged`
        * `warning`
        * `lost`
        * `unknown`
      </td>

      <td style={{ textAlign: "left" }} />
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        `original_network_data`
      </td>

      <td style={{ textAlign: "left" }}>
        object
      </td>

      <td style={{ textAlign: "left" }}>
        Refer to the [VISA Token Service (VTS)\
        Issuer API Specifications (JSON) manual](https://developer.visa.com/capabilities/token-service-provisioning) or the [Mastercard Customer Interface Specification manual](https://techdocs.mastercard.com/bundle/m_CI) for more information on the contents of this field. Note: The Mastercard manual requires a Mastercard Connect ID log in for access.
      </td>

      <td style={{ textAlign: "left" }}>
        No
      </td>
    </tr>
  </tbody>
</Table>

<br /><p style={{fontSize: "large", fontWeight: "bold"}}>Custom codes</p>

<p>VTS = Visa, MDES = Mastercard.</p>

| Custom code  | Description                                                       | VTS action code  | MDES action code |
| :----------- | :---------------------------------------------------------------- | :--------------- | :--------------- |
| `CCS`        | Card status =`CANCELLED`                                          | 46               | 05               |
| `CED`        | Invalid expiration date. Exp date entered does not match Pismo's. | 54               | 05               |
| `CNN`        | Card is not in`NORMAL` status                                     | 05               | 05               |
| `EXPCRD`     | Expired card                                                      | 05               | 05               |
| `FR2`        | Entered CVV2 is invalid                                           | N7               | 05               |
| `FRB`        | `CREATED` status not allowed                                      | 05               | 05               |
| `HSE`        | HSM failed to validate CVV2.                                      | 05               | 05               |
| `NPL`        | Card not plastic. Issuer can override for virtual card.           | 05               | 05               |
| `UBT`        | Blocked card. Legacy                                              | 05               | 05               |
| `ELFR2`      | CVV2 retry limit exceeded                                         | 05               |  05              |
| `MATPC`      |  Exceeded maximum active tokens per card                          | 05               |  05              |
| `FRE`        |  Cryptogram data validation failed                                | 05               |  05              |
Sample request
```json
{
    "card":{
        "id": 134142,
        "type": "PLASTIC",
        "program_id": 1234,
        "bin": "5122"
    },
    "combo_card": { },
    "token_id": 432,
    "network_brand": "vts",
    "custom_codes": ["FRB"],
    "original_network_data": {

    }
}
```
Response fields
<Table align={["left","left","left","left"]}>
  <thead>
    <tr>
      <th style={{ textAlign: "left" }}>
        Field
      </th>

      <th style={{ textAlign: "left" }}>
        Type
      </th>

      <th style={{ textAlign: "left" }}>
        Description
      </th>

      <th style={{ textAlign: "left" }}>
        Required
      </th>
    </tr>
  </thead>

  <tbody>
    <tr>
      <td style={{ textAlign: "left" }}>
        **`approve`**
      </td>

      <td style={{ textAlign: "left" }}>
        boolean
      </td>

      <td style={{ textAlign: "left" }}>
        Card approved flag
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        **`action_code`**
      </td>

      <td style={{ textAlign: "left" }}>
        string
      </td>

      <td style={{ textAlign: "left" }}>
        Decision code:

        * `00` - Approved
        * `05` - Not approved
        * `14` - Invalid PAN
        * `46` - Closed account
        * `54` - Invalid expiration date
        * `57` - Not permitted
        * `58` - Not allowed on terminal
        * `85` - Needs challenge
        * `96` - Issuer internal system error
        * `N7` - Invalid CVV2
      </td>

      <td style={{ textAlign: "left" }}>
        Yes
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        **`step_up_methods`**
      </td>

      <td style={{ textAlign: "left" }}>
        object array
      </td>

      <td style={{ textAlign: "left" }}>
        Needs challenge methods. At least one is required if used.
      </td>

      <td style={{ textAlign: "left" }}>
        Yes if `action_code` = `85`.
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `method`
      </td>

      <td style={{ textAlign: "left" }}>
        enum string
      </td>

      <td style={{ textAlign: "left" }}>
        One-time passcode (OTP) challenge method:

        * `OTPSMS` - SMS
        * `OTPAPP` - App
        * `OTPCALL` - Call
      </td>

      <td style={{ textAlign: "left" }} />
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `value`
      </td>

      <td style={{ textAlign: "left" }}>
        string
      </td>

      <td style={{ textAlign: "left" }}>
        Additional information for challenge - phone number, app, and so on.
      </td>

      <td style={{ textAlign: "left" }} />
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `platform`
      </td>

      <td style={{ textAlign: "left" }}>
        enum string
      </td>

      <td style={{ textAlign: "left" }}>
        Only used for Visa and only when the method is `OPTAPP`:

        * `IOS`
        * `ANDROID`
        * `WINDOWS`
        * `WEB`
      </td>

      <td style={{ textAlign: "left" }} />
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
         `source`
      </td>

      <td style={{ textAlign: "left" }}>
        string
      </td>

      <td style={{ textAlign: "left" }}>
        Only used for Visa and under certain conditions. This is the **Source Address** field as discussed in the VISA VTS manual and you should read that document for more information.
      </td>

      <td style={{ textAlign: "left" }} />
    </tr>
  </tbody>
</Table>
Sample response
```json
{
    "step_up_methods": [
        {
            "method": "OTPCALL",
            "value": "+551130039500"
        },
        {
            "method": "OTPSMS",
            "value": "5327"
        },
        {
            "method": "OTPAPP",
            "value": "app",
            "source": "com.issuer.banking://wallet",
            "platform": "ANDROID"
        }
    ],
    "approve": true,
    "action_code": "85"
}
```
Anti-fraud code sample (Go)
```Text Anti-fraud code sample
package main

// Anti-fraud code sample in Go

//curl --location --request POST 'http://antifraudhost' \
//--header 'x-pismo-sign: eyJhbGciOiJSUzI1NiIsImtpZCI6IjEzY2VlZWViMWEwNjU1Nzg4Y2UyMDg0ZmZmY2FkMDJmNTFmYzMxNDAiLCJ0eXAiOiJKV1QifQ.eyJhY2NvdW50LWlkIjo5ODY2NTM4NiwiYm9keS1oYXNoIjoiUm0yNWNpTy9RRjNMdmIwL1JZbmVWMFZRUkMzd3pNbzZjemdlR1NHUE1KWT0iLCJleHAiOjE2NTI1MzY2MzAsImlhdCI6MTY1MTY3MjYzMCwiaXNzIjoiYXBpLnBpc21vLmlvIiwia2lkIjoiMTNjZWVlZWIxYTA2NTU3ODhjZTIwODRmZmZjYWQwMmY1MWZjMzE0MCIsInN1YiI6ImFwaS1jYXJkcy10b2tlbml6YXRpb24ifQ.bE7l7KQHRj_0J7zcXtLXgefQuGVQjdUr2BtetTQzTf25_tbHf6iUXHIsGB8iCVujo2e5aUrglxTQScduo3sUuJgzLNUHEyBOgMUc9b6v9K_-reFLpJa9Co0Ct8PmU_os-AZr6jqrYgzGk343I_FYDDw48BmqSMRgwtaJPzHQesaSdd8pjAw_CdSttobstplJjQiwUetufmSvZkOCQHeU-JHTwgdcTwgmtJwVMnFFERIdWQMzoz1UYtP0oMJivw3Zt-MjutqvodkaymOIx9IjJTywp0Oq61rmPtWlKW0pIsI6HCYDR8pASgantt7sXGpNb8cdynUIyvxlixpy77kdfg' \
//--header 'Content-Type: application/json' \
//--data-raw '{
//    "card":{
//        "id": 134142,
//        "type": "PLASTIC"
//    },
//    "combo_card": null,
//    "token_id": 432,
//    "network_brand": "vts",
//    "custom_codes": ["FRB", "BNB"],
//    "original_network_data": {}
//}'

import (
	"context"
	"crypto/x509"
	"encoding/json"
	"encoding/pem"
	"fmt"
	"github.com/labstack/echo/v4"
	"github.com/square/go-jose"
	"io/ioutil"
	"net/http"
)

type clientTokenDecision struct {
	Approve       bool                 `json:"approve"`
	ActionCode    string               `json:"action_code"`
	StepUpMethods []clientStepUpMethod `json:"step_up_methods"`
}

type clientStepUpMethod struct {
	Method   string `json:"method"`
	Value    string `json:"value,omitempty"`
	Source   string `json:"source"`
	Platform string `json:"platform"`
}

func main() {
	getPismoCertificates()
	e := echo.New()
	e.POST("/", handler)
	e.Logger.Fatal(e.Start(":1323"))
}

var mapCertificates map[string]*x509.Certificate

func getPismoCertificates() {
	url := "https://sandbox.pismolabs.io/v1/certs"
	httpReq, err := http.NewRequestWithContext(context.Background(), http.MethodGet, url, nil)
	if err != nil {
		panic(err)
	}

	client := http.Client{}
	httpRes, err := client.Do(httpReq)
	if err != nil {
		panic(err)
	}

	if httpRes.StatusCode != http.StatusOK {
		panic(err)
	}

	bRes, err := ioutil.ReadAll(httpRes.Body)
	if err != nil {
		panic(err)
	}

	tmpMap := make(map[string]string)
	err = json.Unmarshal(bRes, &tmpMap)
	if err != nil {
		panic(err)
	}

	mapCertificates = make(map[string]*x509.Certificate)

	for key, val := range tmpMap {
		block, _ := pem.Decode([]byte(val))
		if block == nil {
			panic("cannot decode block")
		}

		cer, err := x509.ParseCertificate(block.Bytes)
		if err != nil {
			panic(err)
		}
		mapCertificates[key] = cer
	}
}

func handler(c echo.Context) error {
	tokenString := c.Request().Header.Get("X-Pismo-Sign")
	valid := isTokenValid(tokenString)
	if !valid {
		return fmt.Errorf("certificate not valid")
	}

	k := clientTokenDecision{

		Approve:    true,
		ActionCode: "85",
		StepUpMethods: []clientStepUpMethod{
			{

				Method: "OTPAPP",
				Value:  "app.to.app",
			},
			{
				Method: "OTPSMS",
			},
		},
	}
	return c.JSON(http.StatusOK, k)
}

func isTokenValid(tokenString string) bool {
	jwsSignature, err := jose.ParseSigned(tokenString)
	if err != nil {
		return false

	}

	for _, sign := range jwsSignature.Signatures {
		kid := sign.Header.KeyID
		cert := mapCertificates[kid]
		_, err := jwsSignature.Verify(cert.PublicKey)

		if err != nil {
			return false
		}
		break
	}
	return true
}
```

Client anti-fraud webhook for banking transaction

This webhook is called during banking operations such as instant pay transactions. Specifically, it would be called during the processing for the following endpoints:

Webhook specifications
Request fields
<HTMLBlock>{`
                                                                                                                                                                                                                                                                                                                            <table>
                                                                                                                                                                                                                                                                                                                            	<tr style="background-color: lightgrey;">
                                                                                                                                                                                                                                                                                                                            		<th>Field</th>;
                                                                                                                                                                                                                                                                                                                            		<th>Type</th>
                                                                                                                                                                                                                                                                                                                            		<th>Description</th>
                                                                                                                                                                                                                                                                                                                            		<th>Req</th>
                                                                                                                                                                                                                                                                                                                            	</tr>
                                                                                                                                                                                                                                                                                                                            	<tr>
                                                                                                                                                                                                                                                                                                                            		<td>
                                                                                                                                                                                                                                                                                                                            				<code>decision</code>
                                                                                                                                                                                                                                                                                                                            		</td>
                                                                                                                                                                                                                                                                                                                            		<td>string</td>
                                                                                                                                                                                                                                                                                                                                <td>Pismo decision<br>Enum: [ "<code>approve</code>". "<code>reject</code>" ]</td>
                                                                                                                                                                                                                                                                                                                            		<td>Y</td>
                                                                                                                                                                                                                                                                                                                            	</tr>
                                                                                                                                                                                                                                                                                                                            	<tr>
                                                                                                                                                                                                                                                                                                                            		<td>
                                                                                                                                                                                                                                                                                                                            				<code>id</code>
                                                                                                                                                                                                                                                                                                                            		</td>
                                                                                                                                                                                                                                                                                                                            		<td>string</td>
                                                                                                                                                                                                                                                                                                                            		<td>Request ID</td>
                                                                                                                                                                                                                                                                                                                            		<td>Y</td>
                                                                                                                                                                                                                                                                                                                            	</tr>
                                                                                                                                                                                                                                                                                                                            	<tr>
                                                                                                                                                                                                                                                                                                                            		<td>
                                                                                                                                                                                                                                                                                                                            				<code>datetime</code>
                                                                                                                                                                                                                                                                                                                            		</td>
                                                                                                                                                                                                                                                                                                                            		<td>string</td>
                                                                                                                                                                                                                                                                                                                            		<td>Call datetime in ISO 8601 format</td>
                                                                                                                                                                                                                                                                                                                            		<td>Y</td>
                                                                                                                                                                                                                                                                                                                            	</tr>
                                                                                                                                                                                                                                                                                                                            	<tr>
                                                                                                                                                                                                                                                                                                                            		<td>
                                                                                                                                                                                                                                                                                                                            				<code>account_id</code>
                                                                                                                                                                                                                                                                                                                            		</td>
                                                                                                                                                                                                                                                                                                                            		<td>string</td>
                                                                                                                                                                                                                                                                                                                            		<td>Pismo account ID</td>
                                                                                                                                                                                                                                                                                                                            		<td>Y</td>
                                                                                                                                                                                                                                                                                                                            	</tr>
                                                                                                                                                                                                                                                                                                                            	<tr>
                                                                                                                                                                                                                                                                                                                            		<td>
                                                                                                                                                                                                                                                                                                                            				<code>currency_code</code>
                                                                                                                                                                                                                                                                                                                            		</td>
                                                                                                                                                                                                                                                                                                                                <td>string</td>
                                                                                                                                                                                                                                                                                                                            		<td> ISO 4217 currency code. For example: 986=Brazil, 840=US.</td>
                                                                                                                                                                                                                                                                                                                            		<td>Y</td>
                                                                                                                                                                                                                                                                                                                            	</tr>
                                                                                                                                                                                                                                                                                                                            	<tr>
                                                                                                                                                                                                                                                                                                                            		<td>
                                                                                                                                                                                                                                                                                                                            				<code>amount</code>
                                                                                                                                                                                                                                                                                                                            		</td>
                                                                                                                                                                                                                                                                                                                            		<td>number</td>
                                                                                                                                                                                                                                                                                                                            		<td>Transaction amount</td>
                                                                                                                                                                                                                                                                                                                            		<td>Y</td>
                                                                                                                                                                                                                                                                                                                            	</tr>
                                                                                                                                                                                                                                                                                                                            	<tr>
                                                                                                                                                                                                                                                                                                                            		<td>
                                                                                                                                                                                                                                                                                                                            				<code>origin</code>
                                                                                                                                                                                                                                                                                                                            		</td>
                                                                                                                                                                                                                                                                                                                            		<td>string</td>
                                                                                                                                                                                                                                                                                                                            		<td>Transaction origin:
                                                                                                                                                                                                                                                                                                                            			<br>Enum:[
                                                                                                                                                                                                                                                                                                                            					"<code>banking</code>", 
                                                                                                                                                                                                                                                                                                                                      "<code>instant-pay</code>".
                                                                                                                                                                                                                                                                                                                                      "<code>onus</code>"]
                                                                                                                                                                                                                                                                                                                            				</td>
                                                                                                                                                                                                                                                                                                                            				<td>Y</td>
                                                                                                                                                                                                                                                                                                                            			</tr>
                                                                                                                                                                                                                                                                                                                            			<tr>
                                                                                                                                                                                                                                                                                                                            				<td>
                                                                                                                                                                                                                                                                                                                            						<code>operation_type</code>
                                                                                                                                                                                                                                                                                                                            				</td>
                                                                                                                                                                                                                                                                                                                            				<td>string</td>
                                                                                                                                                                                                                                                                                                                            				<td>Operation type:
                                                                                                                                                                                                                                                                                                                            					<br>Enum: [
                                                                                                                                                                                                                                                                                                                            						
                                                                                                                                                                                                                                                                                                                            							"<code>cashin</code>",
                                                                                                                                                                                                                                                                                                                                          "<code>cashout</code>" ]
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>Y</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td>
                                                                                                                                                                                                                                                                                                                            								<code>processing_code</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>string</td>
                                                                                                                                                                                                                                                                                                                            						<td>Processing code. For more information see 
                                                                                                                                                                                                                                                                                                                            							<a href="https://developers.pismo.io/pismo-docs/docs/processing-codes-and-transaction-types">Processing codes and transaction types</a>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>Y</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr style="background-color: beige;">
                                                                                                                                                                                                                                                                                                                            						<td>
                                                                                                                                                                                                                                                                                                                            							
                                                                                                                                                                                                                                                                                                                            								<code>entities</code>
                                                                                                                                                                                                                                                                                                                            							
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>object</td>
                                                                                                                                                                                                                                                                                                                            						<td>Details of entities related to the transaction.</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr style="background-color: beige;">
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 30px;">
                                                                                                                                                                                                                                                                                                                            							
                                                                                                                                                                                                                                                                                                                            								<code>account</code>
                                                                                                                                                                                                                                                                                                                            							
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>object</td>
                                                                                                                                                                                                                                                                                                                            						<td>Account information.</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 60px;">
                                                                                                                                                                                                                                                                                                                            							<code>name</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>string</td>
                                                                                                                                                                                                                                                                                                                            						<td>Customer name</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 60px;">
                                                                                                                                                                                                                                                                                                                            							<code>document_number</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>string</td>
                                                                                                                                                                                                                                                                                                                            						<td>Customer government document number.</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 60px;">
                                                                                                                                                                                                                                                                                                                            							<code>creation_date</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>string</td>
                                                                                                                                                                                                                                                                                                                            						<td>Creation datetime in ISO 8601 format.</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr style="background-color: beige;">
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 60px;">
                                                                                                                                                                                                                                                                                                                            							<code>
                                                                                                                                                                                                                                                                                                                            								limits
                                                                                                                                                                                                                                                                                                                            							</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>object</td>
                                                                                                                                                                                                                                                                                                                            						<td>Limits</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 90px;">
                                                                                                                                                                                                                                                                                                                            							<code>total</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>number</td>
                                                                                                                                                                                                                                                                                                                            						<td>Total</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr style="background-color: beige;">
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 60px;">
                                                                                                                                                                                                                                                                                                                            							<code>
                                                                                                                                                                                                                                                                                                                            								address
                                                                                                                                                                                                                                                                                                                            							</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>object</td>
                                                                                                                                                                                                                                                                                                                            						<td>Address information.</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 90px;">
                                                                                                                                                                                                                                                                                                                            							<code>zipcode</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>string</td>
                                                                                                                                                                                                                                                                                                                            						<td>Postal code</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr style="background-color: beige;">
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 60px;">
                                                                                                                                                                                                                                                                                                                            							<code>
                                                                                                                                                                                                                                                                                                                            								phone
                                                                                                                                                                                                                                                                                                                            							</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>object</td>
                                                                                                                                                                                                                                                                                                                            						<td>Phone information.</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 90px;">
                                                                                                                                                                                                                                                                                                                            							<code>area</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>string</td>
                                                                                                                                                                                                                                                                                                                            						<td>Area code.</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 90px;">
                                                                                                                                                                                                                                                                                                                            							<code>country</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>string</td>
                                                                                                                                                                                                                                                                                                                            						<td>Country code.</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr>
                                                                                                                                                                                                                                                                                                                            						<td style="padding-left: 90px;"}>
                                                                                                                                                                                                                                                                                                                            							<code>number</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>string</td>
                                                                                                                                                                                                                                                                                                                            						<td>Phone number</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            					<tr style="background-color: beige;">
                                                                                                                                                                                                                                                                                                                            						<td>
                                                                                                                                                                                                                                                                                                                            							<code>
                                                                                                                                                                                                                                                                                                                            								metadata
                                                                                                                                                                                                                                                                                                                            							</code>
                                                                                                                                                                                                                                                                                                                            						</td>
                                                                                                                                                                                                                                                                                                                            						<td>object</td>
                                                                                                                                                                                                                                                                                                                            						<td>Any JSON name-value pairs</td>
                                                                                                                                                                                                                                                                                                                            						<td>N</td>
                                                                                                                                                                                                                                                                                                                            					</tr>
                                                                                                                                                                                                                                                                                                                            				</tr>
                                                                                                                                                                                                                                                                                                                            		<tr style="background-color: beige;">
                                                                                                                                                                                                                                                                                                                            			<td>
                                                                                                                                                                                                                                                                                                                            				<code>
                                                                                                                                                                                                                                                                                                                            					raw
                                                                                                                                                                                                                                                                                                                            				</code>
                                                                                                                                                                                                                                                                                                                            			</td>
                                                                                                                                                                                                                                                                                                                            			<td>object</td>
                                                                                                                                                                                                                                                                                                                            			<td>Platform additional information forwarded to the anti-fraud system, varies  according to origin. Sent only in on-us transactions.</td>
                                                                                                                                                                                                                                                                                                                            			<td>N</td>
                                                                                                                                                                                                                                                                                                                            		</tr>
                                                                                                                                                                                                                                                                                                                            			</table>
`}</HTMLBlock>
Sample request
```json
{
  "decision": "approve",
  "id": "id",
  "datetime": "2022-07-28T12:45:12.566Z",
  "account_id": 102334690,
  "currency_code": "986",
  "amount": 20,
  "origin": "banking",
  "operation_type": "cashin",
  "processing_code": "003100",
  "entities": {
    "account": {
      "name": "Anne Arbor",
      "document_number": "8675309",
      "creation_date": "2023-01-01T05:00:00.000Z",
      "limits": {
        "total": 1000
      },
      "address": {
        "zipcode": 8675309
      },
      "phone": {
        "area": "415",
        "country": "55",
        "number": "8675309"
      }
    }
  },
  "metadata": {
    "a": false,
    "b": 1,
    "c": "test",
    "d": {
      "d1": "4683bf0c-20d2-4a7f-8877-5f3e9b46252c",
      "d2": false,
      "d3": 15
    }
  }
}
```
Response fields
<HTMLBlock>{`
                                                                                                                                                                                                                                                                                                                            <table>
                                                                                                                                                                                                                                                                                                                            	<tr style="background-color: lightgrey";>
                                                                                                                                                                                                                                                                                                                            		<th>Field</th>
                                                                                                                                                                                                                                                                                                                            		<th>Type</th>
                                                                                                                                                                                                                                                                                                                            		<th>Description</th>
                                                                                                                                                                                                                                                                                                                            		<th>Req</th>
                                                                                                                                                                                                                                                                                                                            	</tr>
                                                                                                                                                                                                                                                                                                                            	<tr>
                                                                                                                                                                                                                                                                                                                            		<td>
                                                                                                                                                                                                                                                                                                                            			<code>decision</code>
                                                                                                                                                                                                                                                                                                                            		</td>
                                                                                                                                                                                                                                                                                                                            		<td>string</td>
                                                                                                                                                                                                                                                                                                                            		<td>Client decision
                                                                                                                                                                                                                                                                                                                            			<br>Enum: [ "
                                                                                                                                                                                                                                                                                                                            				<code>approve</code>", "
                                                                                                                                                                                                                                                                                                                            				<code>reject</code>"]
                                                                                                                                                                                                                                                                                                                            			</td>
                                                                                                                                                                                                                                                                                                                            			<td>Y</td>
[...]
